head	1.5;
access;
symbols;
locks;
comment	@// @;


1.5
date	97.03.21.15.07.55;	author dz;	state Exp;
branches;
next	1.4;

1.4
date	97.03.21.14.32.39;	author dz;	state Exp;
branches;
next	1.3;

1.3
date	97.03.19.14.08.32;	author dz;	state Exp;
branches;
next	1.2;

1.2
date	97.03.19.14.01.55;	author dz;	state Exp;
branches;
next	1.1;

1.1
date	97.03.19.13.55.23;	author dz;	state Exp;
branches;
next	;


desc
@@


1.5
log
@dialing detector
@
text
@
  /*
   *
   *
   * DCD monitor for phone line load tester
   *
   * (C) 1997 dz
   *
   *
   *
   */
    


#define INCL_DOSFILEMGR
#define INCL_DOSDEVICES
#define INCL_DOSDEVIOCTL
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#include <os2.h>

#include <iostream.h>


class port
    {
    HFILE   hf;                         // COM port
    public:
        enum state { BUSY = 1, FREE = 0, INIT = 2 };

        void open( char *name );
        void close();
        state  dcd();

        port() { hf = -1; }
        ~port() { if( hf >= 0 ) close(); }


    };


void port::open( char *name )
    {
    APIRET  rc;                         //  p
    ULONG   ulAction;                   //  p DosOpen
    rc = DosOpen( name, &hf, &ulAction, 0,
                 FILE_NORMAL, FILE_OPEN,
                 OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYNONE,
                 (PEAOP2) NULL);

    if( rc )
        {
        cerr << "Can't open " << name << ", exiting\n";
        throw "Can't open port";
        }
    }

void port::close()
    {
    DosClose(hf);  // p  ᮡ 䠩
    }



port::state  port::dcd()
    {
    APIRET  rc;                         //  p
    ULONG   ulParmLen = 2;              // p ᯨ᪠ pp
    UCHAR   ucStatus;     /* The COM port status byte           */
    ULONG   ulStatusLen;  /* Length of status (the data packet) */

    rc = DosDevIOCtl(
                     hf, IOCTL_ASYNC, ASYNC_GETMODEMINPUT,
                     NULL, 0, NULL,
                     (PULONG) &ucStatus, sizeof(ucStatus), &ulStatusLen
                    );

    if( rc )
        {
        cerr << "Can't get DCD state\n";
        throw "Can't get DCD state";
        }
    
    return ucStatus & DCD_ON ? BUSY : FREE;
    }



port p;

int main( int ac, char **av )
    {
    APIRET  rc;                         //  p

    if( ac < 2 )
        {
        cerr << "Com port name must be given at command line\n";
        return 1;
        }

    p.open( av[1] );


    HEV hevWriteEvent;

    DosCreateEventSem("\\sem32\\dcd_tracker",         /* Named-shared semaphore */
                      &hevWriteEvent, 0, FALSE);      /* Initially reset        */

    
    port::state old_dcd = port::INIT;
    
    //int i = 100;
    while(1)
        {
        DosSleep( 1000 );

        port::state dcd = p.dcd();

        if( dcd == port::FREE && old_dcd != port::FREE )
            {
              // DCD changed from BUSY to FREE - check it by
              // sampling it 10 times each 50 ms to protect
              // against treating dial pulse as free line

            cout << "Checking busy -> free transition...\r";
            cout.flush();
            
            for( int i = 10; i--; )
                {
                if( p.dcd() == port::BUSY ) // Got BUSY?
                    {
                    dcd = port::BUSY;       // Well, we can't report a free line
                    cout << "Dialing detected, line still busy.\r";
                    cout.flush();
                    break;
                    }
                DosSleep( 50 );
                }
            }
            
        if( old_dcd == dcd )
            continue;
        old_dcd = dcd;
        

        // DCD state is changed, lets react accordingly
        
        cout << "Line is " <<
            (char*)(dcd == port::BUSY ?
                    "occupied (DCD ON)                                \r"
                    :
                    "free (dcd off)                                   \r");
        cout.flush();
        
        if( dcd == port::BUSY )
            {
            ULONG   ulPostCt;   /* Post count for the event semaphore (returned) */
            rc = DosResetEventSem(hevWriteEvent, &ulPostCt);
            if( rc && rc != 300 )
                {
                cout << "DosResetEventSem error: " << rc << "\n";
                break;
                }
            }
        else
            {
            rc = DosPostEventSem(hevWriteEvent);                 /* Posts the event        */
            if( rc && rc != 298 && rc != 299 )
                {
                cout << "DosPostEventSem error: " << rc << "\n";
                break;
                }
            }
        
        

        }

    
    DosCloseEventSem(hevWriteEvent);
    }




 
 
 
        @


1.4
log
@*** empty log message ***
@
text
@d25 1
a25 1
int main( int ac, char **av )
d27 11
d39 13
a51 1
    if( ac < 2 )
d53 2
a54 2
        cerr << "Com port name must be given at command line\n";
        return 1;
d56 7
a63 2
    char *port = av[1];
    
d65 3
a67 2
    HFILE   hf;                         // pp 䠩
    USHORT  usBPS = 9600;               // p
d69 2
a70 2
    ULONG   ulAction;                   //  p DosOpen
    APIRET  rc;                         //  p
d72 5
a76 4
    rc = DosOpen( port, &hf, &ulAction, 0,
                 FILE_NORMAL, FILE_OPEN,
                 OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYNONE,
                 (PEAOP2) NULL);
d80 2
a81 2
        cerr << "Can't open " << port << ", exiting\n";
        return 2;
d83 19
d110 1
a110 1
    int old_dcd = 2;
d117 1
a117 11
        UCHAR   ucStatus;     /* The COM port status byte           */
        ULONG   ulStatusLen;  /* Length of status (the data packet) */
        rc = DosDevIOCtl(hf,                  /* Device handle                    */
                         IOCTL_ASYNC,         /* Serial-device control            */
                         ASYNC_GETMODEMINPUT,
                         NULL,                /* No parameter packet              */
                         0,                   /* Maximum size of parameter packet */
                         NULL,                /* Length of parameter packet       */
                         (PULONG) &ucStatus,  /* Data packet                      */
                         sizeof(ucStatus),    /* Maximum size of data packet      */
                         &ulStatusLen);       /* Length of data packet            */
d119 5
a123 1
        int dcd = ucStatus & DCD_ON ? 1 : 0;
d125 1
a125 3
        if( old_dcd != dcd )
            {
            cout << "DCD is " << (char*)(dcd ? "ON (line is occupied)     \r" : "off (line is not occupied) \r");
d127 2
a128 3
            old_dcd = dcd;

            if( dcd )
d130 1
a130 3
                ULONG   ulPostCt;   /* Post count for the event semaphore (returned) */
                rc = DosResetEventSem(hevWriteEvent, &ulPostCt);
                if( rc && rc != 300 )
d132 3
a134 1
                    cout << "DosResetEventSem error: " << rc << "\n";
d137 26
d164 5
a168 1
            else
d170 2
a171 6
                rc = DosPostEventSem(hevWriteEvent);                 /* Posts the event        */
                if( rc && rc != 298 && rc != 299 )
                    {
                    cout << "DosPostEventSem error: " << rc << "\n";
                    break;
                    }
a172 2


d174 2
a179 1
    rc = DosClose(hf);  // p  ᮡ 䠩
@


1.3
log
@*** empty log message ***
@
text
@d1 14
d84 1
a84 1
            cout << "DCD is " << (char*)(dcd ? "ON \r" : "off \r");
d89 9
a97 1
                DosPostEventSem(hevWriteEvent);                 /* Posts the event        */
d100 6
a105 2
                ULONG   ulPostCt;   /* Post count for the event semaphore (returned) */
                DosResetEventSem(hevWriteEvent, &ulPostCt);
a120 105
#if 0

 
 Processes create an event semaphore by using DosCreateEventSem. The process that controls the event or 
 resource is usually the one that creates the semaphore, but it does not have to be. 

 Threads in the process that creates the semaphore do not have to open the semaphore before using it. 
 DosCreateEventSem obtains access to the semaphore for the calling process and its threads. Threads in other 
 processes must call DosOpenEventSem to open the semaphore before they can use it. 

 Event semaphores can be defined as either private or shared: 

      Private semaphores are always unnamed and are therefore always identified by their handles. They can be 
       used only by threads within a single process. 

      Shared semaphores can be either named or unnamed. If named, they can be opened using either the name 
       or the handle. The handle returned by DosOpenEventSem is then used to identify the semaphore for all 
       other functions. Semaphore names must include the prefix \SEM32\ and must conform to file system naming 
       conventions. Shared semaphores can be used by threads in multiple processes. 
  
  In the following code fragment, the controlling process creates a named event semaphore and posts the 
  semaphore after writing data to a shared file: 
  

  
      #define INCL_DOSSEMAPHORES   /* Semaphore values */
      #include <os2.h>
  
      HEV hevWriteEvent;
  
      DosCreateEventSem("\\sem32\\wrtevent",          /* Named-shared semaphore */
                         &hevWriteEvent, 0, FALSE);   /* Initially reset        */
          .
          .
          /* Write data to shared file. */
          .
          .
      DosPostEventSem(hevWriteEvent);                 /* Posts the event        */
          .
          .    /* Continue execution. */
          .
  
  There is a system-wide limit of 65536 (64K) shared semaphores (including mutex, event, and muxwait 
  semaphores); in addition, each process can have up to 65536 (64K) private semaphores. 

  When an event semaphore is created, a flag is used to specify the initial state of the event semaphore, either 
  reset or posted. If the initial state is reset, a thread that calls DosWaitEventSem will be blocked until a process 
  that has access to the semaphore uses DosPostEventSem to post the event semaphore. If the initial state is 
  posted, then a thread that calls DosWaitEventSem will return immediately to continue its execution. If the thread 
  calling DosWaitEventSem is not in the process that created the semaphore, the thread must open the semaphore 
  with DosOpenEventSem before calling DosWaitEventSem. 

  OS/2 maintains a usage count for each semaphore. DosCreateEventSem initializes the usage count to 1. 
  Thereafter, each call to DosOpenEventSem increments the count, and each call to DosCloseEventSem decrements 
  it. 




 
 DosResetEventSem resets an event semaphore if it is not already reset, and returns the number of times the 
 semaphore was posted since it was last reset. All threads that subsequently call DosWaitEventSem for this 
 semaphore will be blocked. 

 Any thread belonging to the process that created the event semaphore can change the state of the semaphore 
 to reset by calling DosResetEventSem. Threads in other processes can also call DosResetEventSem, but they 
 must first gain access to the semaphore by calling DosOpenEventSem. 

 When an event semaphore is in the reset state, any thread that calls DosWaitEventSem to wait for the 
 semaphore will be blocked. When the event semaphore is posted, all of the threads that are waiting for the 
 semaphore are released to continue execution. 

 The following code fragment resets an event semaphore. Assume that the handle of the semaphore has been 
 placed into HEV already. 
 

 
     #include <os2.h>
     #include <stdio.h>
 
     HEV     hev;        /* Event semaphore handle                        */
     ULONG   ulPostCt;   /* Post count for the event semaphore (returned) */
     APIRET  ulrc;       /* Return code                                   */
 
     ulrc = DosResetEventSem(hev, &ulPostCt);
 
     if (ulrc != 0) {
         printf("DosResetEventSem error: return code = %ld",
                ulrc);
         return;
     }
 
 
 DosResetEventSem returns the post count of the event semaphore and resets the post count to 0. The post 
 count is the number of times the semaphore has been posted (using DosPostEventSem) since the last time the 
 semaphore was in the reset state. (An event semaphore can be reset when it is created, as well as by calling 
 DosResetEventSem.) The post count can also be obtained by calling DosQueryEventSem. 

 If the event semaphore is already reset when DosResetEventSem is called, ERROR_ALREADY_RESET is returned, 
 along with a post count of 0. The semaphore is not reset a second time. 

              


#endif
@


1.2
log
@*** empty log message ***
@
text
@d5 1
d49 2
a50 2
    int i = 100;
    while(i--)
d79 1
a79 1
                DosResetEventSem(hev, &ulPostCt);
a171 1
     #define INCL_DOSSEMAPHORES   /* Semaphore values */
@


1.1
log
@Initial revision
@
text
@a38 11
/*
    rc = DosDevIOCtl(hf,                // pp p⢠
                     IOCTL_ASYNC,       //  㤥   ⮣ 
                     ASYNC_SETBAUDRATE, // p⭮ - ⠭ ᪮p
                     (PULONG) &usBPS,   // p 㤥  ⠪
                     sizeof(usBPS),     // p p饣 pp -  ⠪
                     &ulParmLen,        //  p쭮 -  ⮫쪮 ᯮ짮
                     NULL,              //    ᯮ㥬   p
                     0,                 // ⮬   㫥 pp
                     NULL);             //  p쭮 pp   
*/
d40 6
d48 1
a48 1
    int i = 1000;
d51 1
a51 1
        DosSleep( 100 );
a56 1
                           //ASYNC_GETCOMMSTATUS, /* Get the COM status byte          */
d72 10
d88 3
a92 1
    }
d94 98
d193 2
d196 1
d199 1
@
