
  /*
   *
   *
   * DCD monitor for phone line load tester
   *
   * (C) 1997 dz
   *
   *
   *
   */
    


#define INCL_DOSFILEMGR
#define INCL_DOSDEVICES
#define INCL_DOSDEVIOCTL
#define INCL_DOSPROCESS
#define INCL_DOSSEMAPHORES
#include <os2.h>

#include <iostream.h>


class port
    {
    HFILE   hf;                         // COM port
    public:
        enum state { BUSY = 1, FREE = 0, INIT = 2 };

        void open( char *name );
        void close();
        state  dcd();

        port() { hf = -1; }
        ~port() { if( hf >= 0 ) close(); }


    };


void port::open( char *name )
    {
    APIRET  rc;                         //  p
    ULONG   ulAction;                   //  p DosOpen
    rc = DosOpen( name, &hf, &ulAction, 0,
                 FILE_NORMAL, FILE_OPEN,
                 OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYNONE,
                 (PEAOP2) NULL);

    if( rc )
        {
        cerr << "Can't open " << name << ", exiting\n";
        throw "Can't open port";
        }
    }

void port::close()
    {
    DosClose(hf);  // p  ᮡ 䠩
    }



port::state  port::dcd()
    {
    APIRET  rc;                         //  p
    ULONG   ulParmLen = 2;              // p ᯨ᪠ pp
    UCHAR   ucStatus;     /* The COM port status byte           */
    ULONG   ulStatusLen;  /* Length of status (the data packet) */

    rc = DosDevIOCtl(
                     hf, IOCTL_ASYNC, ASYNC_GETMODEMINPUT,
                     NULL, 0, NULL,
                     (PULONG) &ucStatus, sizeof(ucStatus), &ulStatusLen
                    );

    if( rc )
        {
        cerr << "Can't get DCD state\n";
        throw "Can't get DCD state";
        }
    
    return ucStatus & DCD_ON ? BUSY : FREE;
    }



port p;

int main( int ac, char **av )
    {
    APIRET  rc;                         //  p

    if( ac < 2 )
        {
        cerr << "Com port name must be given at command line\n";
        return 1;
        }

    p.open( av[1] );


    HEV hevWriteEvent;

    DosCreateEventSem("\\sem32\\dcd_tracker",         /* Named-shared semaphore */
                      &hevWriteEvent, 0, FALSE);      /* Initially reset        */

    
    port::state old_dcd = port::INIT;
    
    //int i = 100;
    while(1)
        {
        DosSleep( 1000 );

        port::state dcd = p.dcd();

        if( dcd == port::FREE && old_dcd != port::FREE )
            {
              // DCD changed from BUSY to FREE - check it by
              // sampling it 10 times each 50 ms to protect
              // against treating dial pulse as free line

            cout << "Checking busy -> free transition...\r";
            cout.flush();
            
            for( int i = 10; i--; )
                {
                if( p.dcd() == port::BUSY ) // Got BUSY?
                    {
                    dcd = port::BUSY;       // Well, we can't report a free line
                    cout << "Dialing detected, line still busy.\r";
                    cout.flush();
                    break;
                    }
                DosSleep( 50 );
                }
            }
            
        if( old_dcd == dcd )
            continue;
        old_dcd = dcd;
        

        // DCD state is changed, lets react accordingly
        
        cout << "Line is " <<
            (char*)(dcd == port::BUSY ?
                    "occupied (DCD ON)                                \r"
                    :
                    "free (dcd off)                                   \r");
        cout.flush();
        
        if( dcd == port::BUSY )
            {
            ULONG   ulPostCt;   /* Post count for the event semaphore (returned) */
            rc = DosResetEventSem(hevWriteEvent, &ulPostCt);
            if( rc && rc != 300 )
                {
                cout << "DosResetEventSem error: " << rc << "\n";
                break;
                }
            }
        else
            {
            rc = DosPostEventSem(hevWriteEvent);                 /* Posts the event        */
            if( rc && rc != 298 && rc != 299 )
                {
                cout << "DosPostEventSem error: " << rc << "\n";
                break;
                }
            }
        
        

        }

    
    DosCloseEventSem(hevWriteEvent);
    }




 
 
 
        